export default class FormCore {
    constructor(options: FormCoreOptions);
    private emitter;
    validator: Validator;
    fields: Map<any, any>;
    private initialSchema;
    private initialData;
    state: State;
    reset(): void;
    submit(): any;
    update(update: {
        path: (string | number)[];
        value: any;
    }): void;
    validateAll(data: any): {
        [x: string]: string[];
    };
    getState(): any;
    setState(state: any): void;
    changed(state: any): void;
    setProperty(property: any, value: any): void;
    on(event: any, callback: any): void;
    off(event: any, callback: any): void;
}
export type Schema = any;
export type Data = {
    [x: string]: any;
};
export type Errors = {
    [x: string]: string[];
};
export type Properties = {
    [x: string]: any;
};
export type FormCoreOptions = {
    data: Data;
    schema: Schema;
    properties?: Properties;
};
export type State = {
    data: Data;
    errors: Errors;
    schema: Schema;
    properties: Properties;
};
import { Validator } from "./validation";
